/// <reference types="node" />
/// <reference types="node/http" />
/// <reference types="got/dist/source/core/utils/timed-out" />
import { Options, Got } from "got";
import { PrometheusMeter } from "../metrics";
export declare const httpClientPlugin: import("fastify").FastifyPluginAsync<HttpClientPluginOptions, import("http").Server>;
declare class HttpClientRequestDecoration {
    private readonly appHttpClient;
    private readonly correlationId;
    private readonly correlationIdHeader;
    constructor(appHttpClient: HttpClient, correlationId: string, correlationIdHeader: string);
    /**
     * Creates a request-specific HTTP client.
     * @param opts HTTP request options
     */
    create(options?: HttpClientOptions): HttpClient;
}
export declare type HttpClient = Got;
export declare type HttpClientOptions = Options;
export declare type HttpClientResponse = import("got").Response;
export declare type HttpClientFactory = (opts?: HttpClientOptions) => HttpClient;
export interface HttpClientPluginOptions {
    defaultOptions?: HttpClientOptions;
    correlationIdHeader?: string;
    prometheusMeter?: PrometheusMeter;
}
declare module "fastify" {
    interface FastifyInstance {
        httpClient: HttpClient;
    }
    interface FastifyRequest {
        httpClient: HttpClientRequestDecoration;
    }
}
export {};
