"use strict";
/* eslint-disable no-console */
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.collectLogsUntil = exports.nextLog = exports.createDestinationStream = void 0;
const events_1 = require("events");
const split2_1 = __importDefault(require("split2"));
const flush_write_stream_1 = __importDefault(require("flush-write-stream"));
const rx = __importStar(require("rxjs"));
const rxOp = __importStar(require("rxjs/operators"));
// helper function copied from pino tests
function createDestinationStream(func) {
    const result = (0, split2_1.default)((data) => {
        try {
            // eslint-disable-next-line @typescript-eslint/no-unsafe-return
            return JSON.parse(data);
        }
        catch (err) {
            console.log(err);
            console.log(data);
        }
    });
    if (func)
        result.pipe(flush_write_stream_1.default.obj(func));
    return result;
}
exports.createDestinationStream = createDestinationStream;
async function nextLog(destinationStream) {
    // eslint-disable-next-line @typescript-eslint/no-unsafe-assignment
    const [log] = await (0, events_1.once)(destinationStream, "data");
    // eslint-disable-next-line @typescript-eslint/no-unsafe-return
    return log;
}
exports.nextLog = nextLog;
function collectLogsUntil(destinationStream, stopPromise, consoleLogItems = false) {
    let stream = rx.fromEvent(destinationStream, "data");
    if (consoleLogItems) {
        // eslint-disable-next-line @typescript-eslint/no-unsafe-assignment
        stream = stream.pipe(rxOp.tap(console.log));
    }
    return rx.firstValueFrom(stream.pipe(rxOp.takeUntil(rx.from(stopPromise)), rxOp.toArray()));
}
exports.collectLogsUntil = collectLogsUntil;
