"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.checkLoggingOptionsPlausibility = exports.createLoggers = void 0;
const root_logger_1 = require("./root_logger");
const options_1 = require("../utils/options");
function createLoggers(serviceName, loggingOpts) {
    const rootLogger = (0, root_logger_1.createRootLogger)(serviceName, loggingOpts || undefined);
    const appLogger = rootLogger.child({ log_type: "application" });
    return { rootLogger, appLogger };
}
exports.createLoggers = createLoggers;
function checkLoggingOptionsPlausibility(appLogger, opts, finalFastifyOpts) {
    if (opts.fastify?.logger !== undefined) {
        appLogger.warn("You have provided fastify.logger options, but they will be ignored. Use the skeleton's logger options instead.");
    }
    if (finalFastifyOpts.disableRequestLogging !== true &&
        (0, options_1.isOptionEnabled)(opts.plugins?.requestLogging, opts.enablePluginsByDefault)) {
        appLogger.warn("You have enabled fastify's default request logging in addition to the requestLogging plugin.");
    }
}
exports.checkLoggingOptionsPlausibility = checkLoggingOptionsPlausibility;
