"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createRootLogger = void 0;
const os = __importStar(require("os"));
const pino_1 = __importDefault(require("pino"));
const date_utils_1 = require("../utils/date_utils");
const options_1 = require("../utils/options");
function createRootLogger(serviceName, opts) {
    const baseDefaults = {
        application_type: "service",
        service: serviceName,
        host: os.hostname(),
    };
    const pinoOpts = {
        enabled: (0, options_1.isOptionEnabled)(opts, true),
        base: opts?.base ? { ...baseDefaults, ...opts.base } : baseDefaults,
        timestamp: epochTimeAndIso8601WithLocalOffset,
        customLevels: uppercasePinoLevels,
        formatters: {
            level(label, _number) {
                return {
                    loglevel: label,
                };
            },
        },
        ...opts,
    };
    return opts?.destination ? (0, pino_1.default)(pinoOpts, opts?.destination) : (0, pino_1.default)(pinoOpts);
}
exports.createRootLogger = createRootLogger;
const uppercasePinoLevels = Object.entries(pino_1.default.levels.values).reduce((acc, [key, val]) => {
    acc[key.toUpperCase()] = val;
    return acc;
}, {});
function epochTimeAndIso8601WithLocalOffset() {
    const now = new Date();
    return `,"time":${now.getTime()},"@timestamp":"${(0, date_utils_1.iso8601WithLocalOffset)(now)}"`;
}
