"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const fastify_1 = __importDefault(require("fastify"));
const _1 = require(".");
describe("Metrics plugin", () => {
    it("exposes metrics via an http endpoint", async () => {
        const app = (0, fastify_1.default)().register(_1.metricsPlugin);
        await app.ready();
        const res = await app.inject({ method: "GET", url: "/admin/metrics" });
        expect(res.statusCode).toBe(200);
        expect(res.headers["content-type"]).toBe("text/plain; version=0.0.4");
        expect(typeof res.payload).toBe("string");
        await app.close();
    });
});
