import * as promClient from "prom-client";
import type { PrometheusMeter } from "./prometheus_meter_interface";
export declare function createPrometheusMeter(defaultRegisters: promClient.Registry[], Counter?: typeof promClient.Counter, Gauge?: typeof promClient.Gauge, Histogram?: typeof promClient.Histogram, Summary?: typeof promClient.Summary): PrometheusMeter;
export declare const duplicateStrategies: {
    preventAnyDuplicate: typeof preventAnyDuplicate;
    returnExistingIfPropsAreEqual: typeof returnExistingIfPropsAreEqual;
};
declare function preventAnyDuplicate<MetricCls extends new (...args: any[]) => Metric, Metric extends promClient.Metric<Labels>, Labels extends string>(MetricClass: MetricCls, config: MetricConfiguration<Labels>, registeredIn: Array<{
    registry: promClient.Registry;
    metric: promClient.Metric<string>;
}>, _notRegisteredIn: promClient.Registry[]): Metric;
declare function returnExistingIfPropsAreEqual<MetricCls extends new (...args: any[]) => Metric, Metric extends promClient.Metric<Labels>, Labels extends string>(MetricClass: MetricCls, config: MetricConfiguration<Labels>, registeredIn: Array<{
    registry: promClient.Registry;
    metric: promClient.Metric<string>;
}>, notRegisteredIn: promClient.Registry[]): Metric;
export declare type CounterConfiguration<Label extends string = string> = promClient.CounterConfiguration<Label> & ExtraMetricOptions;
export declare type GaugeConfiguration<Label extends string = string> = promClient.GaugeConfiguration<Label> & ExtraMetricOptions;
export declare type HistogramConfiguration<Label extends string = string> = promClient.HistogramConfiguration<Label> & ExtraMetricOptions;
export declare type SummaryConfiguration<Label extends string = string> = promClient.SummaryConfiguration<Label> & ExtraMetricOptions;
export declare type MetricConfiguration<Label extends string = string> = CounterConfiguration<Label> | GaugeConfiguration<Label> | HistogramConfiguration<Label> | SummaryConfiguration<Label>;
interface ExtraMetricOptions {
    duplicateStrategy?: DuplicateStrategy;
}
export declare type DuplicateStrategy = <MetricCls extends new (...args: any[]) => Metric, Metric extends promClient.Metric<Labels>, Labels extends string>(MetricClass: MetricCls, config: MetricConfiguration<Labels>, registeredIn: Array<{
    registry: promClient.Registry;
    metric: promClient.Metric<string>;
}>, notRegisteredIn: promClient.Registry[]) => Metric;
export {};
