/// <reference types="node" />
/// <reference types="node/http" />
/// <reference types="got/dist/source/core/utils/timed-out" />
import { FastifyInstance } from "fastify";
import type * as promClient from "prom-client";
import { PrometheusMeter } from "./prometheus_meter";
export declare const requestMetricsPlugin: <ExtraLabel extends string>(instance: FastifyInstance<import("http").Server, import("http").IncomingMessage, import("http").ServerResponse, import("fastify").FastifyLoggerInstance>, opts: RequestMetricsOptions<ExtraLabel>) => Promise<void>;
declare class RequestMetricsAppDecoration<Label extends string> {
    readonly durationHistogram: promClient.Histogram<Label>;
    constructor(durationHistogram: promClient.Histogram<Label>);
}
declare class RequestMetricsRequestDecoration<ExtraLabel extends string> {
    readonly labelNames: ExtraLabel[];
    readonly extraLabels: promClient.LabelValues<ExtraLabel>;
    constructor(labelNames: ExtraLabel[]);
    addLabel(name: ExtraLabel, value: string | number): void;
}
export interface RequestMetricsOptions<ExtraLabel extends string = string> {
    extraLabelNames?: ExtraLabel[];
    prometheusMeter?: PrometheusMeter;
}
declare module "fastify" {
    interface FastifyInstance {
        requestMetrics: RequestMetricsAppDecoration<string>;
    }
    interface FastifyRequest {
        requestMetrics: RequestMetricsRequestDecoration<string>;
    }
}
export {};
