"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const fastify_1 = __importDefault(require("fastify"));
const service_metadata_1 = require("./service_metadata");
describe("Service Name", () => {
    it("adds `serviceName` to fastify", async () => {
        const serviceName = "service-name-test";
        const app = (0, fastify_1.default)().register(service_metadata_1.serviceMetadata, { serviceName });
        await app.ready();
        expect(app.hasDecorator("serviceName"));
        expect(app.serviceName).toBe(serviceName);
        await app.close();
    });
});
