"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.assertIsNonEmptyObject = exports.assertIsNotNullish = exports.assertIsNotUndefined = exports.assert = exports.AssertionError = void 0;
const assert_1 = require("assert");
Object.defineProperty(exports, "AssertionError", { enumerable: true, get: function () { return assert_1.AssertionError; } });
function assert(condition, message) {
    return (0, assert_1.ok)(condition, message);
}
exports.assert = assert;
function assertIsNotUndefined(value, valueName) {
    return assert(value !== undefined, `Expected ${valueName || "value"} to be not undefined`);
}
exports.assertIsNotUndefined = assertIsNotUndefined;
function assertIsNotNullish(value, valueName) {
    return assert(value !== undefined && value !== null, `Expected ${valueName || "value"} to be not undefined or null`);
}
exports.assertIsNotNullish = assertIsNotNullish;
// eslint-disable-next-line @typescript-eslint/ban-types
function assertIsNonEmptyObject(
// eslint-disable-next-line @typescript-eslint/ban-types
obj, valueName) {
    for (const key in obj) {
        if (Object.prototype.hasOwnProperty.call(obj, key)) {
            return;
        }
    }
    throw new assert_1.AssertionError({
        message: `Expected ${valueName || "value"} to be a non-empty object`,
    });
}
exports.assertIsNonEmptyObject = assertIsNonEmptyObject;
