"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const assert_1 = require("./assert");
describe("assert utils", () => {
    describe("assertIsNotUndefined", () => {
        it("throws an AssertionError on undefined", () => {
            expect(() => (0, assert_1.assertIsNotUndefined)(undefined)).toThrowError(assert_1.AssertionError);
            for (const defined of [null, 0, "", {}]) {
                expect(() => (0, assert_1.assertIsNotUndefined)(defined));
            }
        });
    });
    describe("assertIsNotNullish", () => {
        it("throws an AssertionError on null or undefined", () => {
            expect(() => (0, assert_1.assertIsNotNullish)(undefined)).toThrowError(assert_1.AssertionError);
            expect(() => (0, assert_1.assertIsNotNullish)(null)).toThrowError(assert_1.AssertionError);
            for (const defined of [0, "", {}]) {
                expect(() => (0, assert_1.assertIsNotNullish)(defined));
            }
        });
    });
    describe("assertIsNonEmptyObject", () => {
        it("throws an AssertionError on empty objects", () => {
            expect(() => (0, assert_1.assertIsNonEmptyObject)({})).toThrowError(assert_1.AssertionError);
            expect(() => (0, assert_1.assertIsNonEmptyObject)(Object.create(null))).toThrowError(assert_1.AssertionError);
            expect(() => (0, assert_1.assertIsNonEmptyObject)({ a: 1 }));
        });
    });
});
