"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.iso8601WithLocalOffset = void 0;
function iso8601WithLocalOffset(date) {
    const timezoneOffset = -date.getTimezoneOffset();
    const dif = timezoneOffset >= 0 ? "+" : "-";
    return `${date.getFullYear()}-${padNumber(date.getMonth() + 1, 2)}-${padNumber(date.getDate(), 2)}T${padNumber(date.getHours(), 2)}:${padNumber(date.getMinutes(), 2)}:${padNumber(date.getSeconds(), 2)}${dif}${padNumber(timezoneOffset / 60, 2)}:${padNumber(timezoneOffset % 60, 2)}`;
}
exports.iso8601WithLocalOffset = iso8601WithLocalOffset;
function padNumber(num, maxLength) {
    return num.toString().padStart(maxLength, "0");
}
