"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isOptionEnabledByDefaultFalse = exports.isOptionEnabledByDefaultTrue = exports.isOptionEnabled = exports.createIsOptionEnabled = void 0;
function createIsOptionEnabled(enableByDefault = true) {
    return enableByDefault
        ? isOptionEnabledByDefaultTrue
        : isOptionEnabledByDefaultFalse;
}
exports.createIsOptionEnabled = createIsOptionEnabled;
function isOptionEnabled(option, enableByDefault = true) {
    return enableByDefault
        ? isOptionEnabledByDefaultTrue(option)
        : isOptionEnabledByDefaultFalse(option);
}
exports.isOptionEnabled = isOptionEnabled;
function isOptionEnabledByDefaultTrue(option) {
    if (typeof option === "object" && option !== null) {
        return option.enable !== false;
    }
    else {
        return option !== false;
    }
}
exports.isOptionEnabledByDefaultTrue = isOptionEnabledByDefaultTrue;
function isOptionEnabledByDefaultFalse(option) {
    return ((typeof option === "object" &&
        option !== null &&
        option.enable === true) ||
        option === true);
}
exports.isOptionEnabledByDefaultFalse = isOptionEnabledByDefaultFalse;
