"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const _1 = require(".");
test("inferActualType infers the actual type schema based on a given type argument", () => {
    const inferActualSomeObj = (0, _1.inferActualType)();
    // type annotation tests the expected return type
    const someObj = inferActualSomeObj({
        a: { n: 1, s: "test", o: 1 },
        b: 1,
    });
    // as it is just a identity function at runtime, test if input equals output
    expect(someObj).toEqual({
        a: { n: 1, s: "test", o: 1 },
        b: 1,
    });
});
test("inferActualPartialType infers the actual partial type schema based on a given type argument", () => {
    const inferActualPartialOfSomeObj = (0, _1.inferActualPartialType)();
    // type annotation tests the expected return type
    const someObjPartial = inferActualPartialOfSomeObj({
        a: { n: 1, s: "test" },
    });
    // the factory is just a identity function, so test if input equals output
    expect(someObjPartial).toEqual({ a: { n: 1, s: "test" } });
});
test("inferActualPartialType infers the actual deep-partial type schema based on a given type argument", () => {
    const inferActualDeepPartialOfSomeObj = (0, _1.inferActualDeepPartialType)();
    // type annotation tests the expected return type
    const someObjDeepPartial = inferActualDeepPartialOfSomeObj({
        a: { n: 1 },
    });
    // the factory is just a identity function, so test if input equals output
    expect(someObjDeepPartial).toEqual({ a: { n: 1 } });
});
