import * as ajv from "ajv";
export declare class Validator<T> {
    readonly validateFunc: ajv.ValidateFunction<T>;
    readonly schema: ValidationSchema;
    readonly schemaName: string;
    constructor(schemaName: string, schema: ValidationSchema, options?: ajv.Options);
    validate(candidate: unknown, resultHandler?: ValidationResultHandler): candidate is T;
    static assert<T>(validator: Validator<T>, candidate: unknown, resultHandler?: ValidationResultHandler): asserts candidate is T;
}
export declare class ValidationError extends Error {
    readonly candidate: unknown;
    readonly schemaName: string;
    readonly schema: ValidationSchema;
    readonly validationErrors: ajv.ErrorObject[];
    constructor(candidate: unknown, schemaName: string, schema: ValidationSchema, validationErrors: ajv.ErrorObject[]);
}
export declare type ValidationResultHandler = (error: ValidationError | null, context: ValidationContext) => void;
export interface ValidationContext {
    candidate: unknown;
    schema: ValidationSchema;
    schemaName: string;
}
export declare type ValidationSchema = ajv.Schema;
